/*
Copyright 2021 OECP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/oecp/open-local/pkg/apis/storage/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeNodeLocalStorages implements NodeLocalStorageInterface
type FakeNodeLocalStorages struct {
	Fake *FakeStorageV1alpha1
}

var nodelocalstoragesResource = schema.GroupVersionResource{Group: "storage.oecp.io", Version: "v1alpha1", Resource: "nodelocalstorages"}

var nodelocalstoragesKind = schema.GroupVersionKind{Group: "storage.oecp.io", Version: "v1alpha1", Kind: "NodeLocalStorage"}

// Get takes name of the nodeLocalStorage, and returns the corresponding nodeLocalStorage object, and an error if there is any.
func (c *FakeNodeLocalStorages) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NodeLocalStorage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(nodelocalstoragesResource, name), &v1alpha1.NodeLocalStorage{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorage), err
}

// List takes label and field selectors, and returns the list of NodeLocalStorages that match those selectors.
func (c *FakeNodeLocalStorages) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NodeLocalStorageList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(nodelocalstoragesResource, nodelocalstoragesKind, opts), &v1alpha1.NodeLocalStorageList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.NodeLocalStorageList{ListMeta: obj.(*v1alpha1.NodeLocalStorageList).ListMeta}
	for _, item := range obj.(*v1alpha1.NodeLocalStorageList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested nodeLocalStorages.
func (c *FakeNodeLocalStorages) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(nodelocalstoragesResource, opts))
}

// Create takes the representation of a nodeLocalStorage and creates it.  Returns the server's representation of the nodeLocalStorage, and an error, if there is any.
func (c *FakeNodeLocalStorages) Create(ctx context.Context, nodeLocalStorage *v1alpha1.NodeLocalStorage, opts v1.CreateOptions) (result *v1alpha1.NodeLocalStorage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(nodelocalstoragesResource, nodeLocalStorage), &v1alpha1.NodeLocalStorage{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorage), err
}

// Update takes the representation of a nodeLocalStorage and updates it. Returns the server's representation of the nodeLocalStorage, and an error, if there is any.
func (c *FakeNodeLocalStorages) Update(ctx context.Context, nodeLocalStorage *v1alpha1.NodeLocalStorage, opts v1.UpdateOptions) (result *v1alpha1.NodeLocalStorage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(nodelocalstoragesResource, nodeLocalStorage), &v1alpha1.NodeLocalStorage{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorage), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeNodeLocalStorages) UpdateStatus(ctx context.Context, nodeLocalStorage *v1alpha1.NodeLocalStorage, opts v1.UpdateOptions) (*v1alpha1.NodeLocalStorage, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(nodelocalstoragesResource, "status", nodeLocalStorage), &v1alpha1.NodeLocalStorage{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorage), err
}

// Delete takes name of the nodeLocalStorage and deletes it. Returns an error if one occurs.
func (c *FakeNodeLocalStorages) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(nodelocalstoragesResource, name), &v1alpha1.NodeLocalStorage{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeNodeLocalStorages) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(nodelocalstoragesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.NodeLocalStorageList{})
	return err
}

// Patch applies the patch and returns the patched nodeLocalStorage.
func (c *FakeNodeLocalStorages) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodeLocalStorage, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(nodelocalstoragesResource, name, pt, data, subresources...), &v1alpha1.NodeLocalStorage{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorage), err
}
