/*
Copyright 2021 OECP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/oecp/open-local/pkg/apis/storage/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeNodeLocalStorageInitConfigs implements NodeLocalStorageInitConfigInterface
type FakeNodeLocalStorageInitConfigs struct {
	Fake *FakeStorageV1alpha1
}

var nodelocalstorageinitconfigsResource = schema.GroupVersionResource{Group: "storage.oecp.io", Version: "v1alpha1", Resource: "nodelocalstorageinitconfigs"}

var nodelocalstorageinitconfigsKind = schema.GroupVersionKind{Group: "storage.oecp.io", Version: "v1alpha1", Kind: "NodeLocalStorageInitConfig"}

// Get takes name of the nodeLocalStorageInitConfig, and returns the corresponding nodeLocalStorageInitConfig object, and an error if there is any.
func (c *FakeNodeLocalStorageInitConfigs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NodeLocalStorageInitConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(nodelocalstorageinitconfigsResource, name), &v1alpha1.NodeLocalStorageInitConfig{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorageInitConfig), err
}

// List takes label and field selectors, and returns the list of NodeLocalStorageInitConfigs that match those selectors.
func (c *FakeNodeLocalStorageInitConfigs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NodeLocalStorageInitConfigList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(nodelocalstorageinitconfigsResource, nodelocalstorageinitconfigsKind, opts), &v1alpha1.NodeLocalStorageInitConfigList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.NodeLocalStorageInitConfigList{ListMeta: obj.(*v1alpha1.NodeLocalStorageInitConfigList).ListMeta}
	for _, item := range obj.(*v1alpha1.NodeLocalStorageInitConfigList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested nodeLocalStorageInitConfigs.
func (c *FakeNodeLocalStorageInitConfigs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(nodelocalstorageinitconfigsResource, opts))
}

// Create takes the representation of a nodeLocalStorageInitConfig and creates it.  Returns the server's representation of the nodeLocalStorageInitConfig, and an error, if there is any.
func (c *FakeNodeLocalStorageInitConfigs) Create(ctx context.Context, nodeLocalStorageInitConfig *v1alpha1.NodeLocalStorageInitConfig, opts v1.CreateOptions) (result *v1alpha1.NodeLocalStorageInitConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(nodelocalstorageinitconfigsResource, nodeLocalStorageInitConfig), &v1alpha1.NodeLocalStorageInitConfig{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorageInitConfig), err
}

// Update takes the representation of a nodeLocalStorageInitConfig and updates it. Returns the server's representation of the nodeLocalStorageInitConfig, and an error, if there is any.
func (c *FakeNodeLocalStorageInitConfigs) Update(ctx context.Context, nodeLocalStorageInitConfig *v1alpha1.NodeLocalStorageInitConfig, opts v1.UpdateOptions) (result *v1alpha1.NodeLocalStorageInitConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(nodelocalstorageinitconfigsResource, nodeLocalStorageInitConfig), &v1alpha1.NodeLocalStorageInitConfig{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorageInitConfig), err
}

// Delete takes name of the nodeLocalStorageInitConfig and deletes it. Returns an error if one occurs.
func (c *FakeNodeLocalStorageInitConfigs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(nodelocalstorageinitconfigsResource, name), &v1alpha1.NodeLocalStorageInitConfig{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeNodeLocalStorageInitConfigs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(nodelocalstorageinitconfigsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.NodeLocalStorageInitConfigList{})
	return err
}

// Patch applies the patch and returns the patched nodeLocalStorageInitConfig.
func (c *FakeNodeLocalStorageInitConfigs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodeLocalStorageInitConfig, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(nodelocalstorageinitconfigsResource, name, pt, data, subresources...), &v1alpha1.NodeLocalStorageInitConfig{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NodeLocalStorageInitConfig), err
}
